package com.keao.edu.user.service;


import com.keao.edu.common.page.PageInfo;
import com.keao.edu.common.service.BaseService;
import com.keao.edu.user.dto.BasicNeedCheckingDetailDto;
import com.keao.edu.user.dto.ExamCertificationDto;
import com.keao.edu.user.dto.NeedCheckingDetailDto;
import com.keao.edu.user.entity.ExamCertification;
import com.keao.edu.user.page.ExamCertificationQueryInfo;
import org.springframework.data.domain.Page;

import java.util.List;

public interface ExamCertificationService extends BaseService<Long, ExamCertification> {

    /**
     * 获取学员准考证
     * @param examRegistrationId
     * @return
     */
    ExamCertification findByStuAndBasicId(Long examRegistrationId);

    /**
     * 获取学员的准考证列表
     * @return
     */
    List<ExamCertificationDto> queryCertificationPage(Long examRegistrationId);

    /**
     * 学生端待考详情
     * @param examRegistrationId
     * @return
     */
    NeedCheckingDetailDto needCheckingDetail(Long examRegistrationId);

    /**
     * 学生端待考详情
     * @param examRoomId
     * @return
     */
    List<BasicNeedCheckingDetailDto> basicNeedCheckingDetail(Long examRoomId);

    /**
     * 获取后台准考证详情
     * @param examRegistrationId
     * @return
     */
    ExamCertificationDto findDetailByStudentId(Long examRegistrationId);

    void batchInsert(List<ExamCertification> examCertifications);

    int deleteWithRegist(List<Long> registIds);
}